// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "SimpleMouseDrawing.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
	m_nShapeMode = LINE; 
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
}


void CChildView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	::ClipCursor(NULL);		//  콺ư   Ŭ 

	SetCapture(); // MFC Լ ̿Ͽ 콺 ĸó Ѵ.
	// ׸ 忡 Ѵ.
	m_bDrawMode = TRUE; 
	// 콺 Ŀ ǥ Ѵ.
	m_ptStart = m_ptEnd = point; 
	
	CWnd::OnLButtonDown(nFlags, point);
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CClientDC dc(this);
	dc.SelectStockObject(NULL_BRUSH);	

	//   (,簢,Ÿ) ׸.
	dc.SetROP2(R2_COPYPEN); 
	if (m_nShapeMode == LINE) {
		dc.MoveTo(m_ptStart);
		dc.LineTo(m_ptEnd);
	}
	else if (m_nShapeMode == RECTANGLE) {
		dc.Rectangle(m_ptStart.x,m_ptStart.y,m_ptEnd.x,m_ptEnd.y);
	}
	else if (m_nShapeMode == ELLIPSE) {
		dc.Ellipse(m_ptStart.x,m_ptStart.y,m_ptEnd.x,m_ptEnd.y);
	}

	// ׸ 带 Ѵ.
	m_bDrawMode = FALSE;
	::ReleaseCapture(); //  API Լ Ͽ 콺 ĸó Ѵ.
	
	CWnd::OnLButtonUp(nFlags, point);
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	// ׸ ̸   ׸⸦ ݺѴ.
	if(m_bDrawMode) { 
		CClientDC dc(this);
		dc.SelectStockObject(NULL_BRUSH);	

		//  ׸  (,簢,Ÿ) .
		dc.SetROP2(R2_NOT); 
		if (m_nShapeMode == LINE) {
			dc.MoveTo(m_ptStart);
			dc.LineTo(m_ptEnd);
		}
		else if (m_nShapeMode == RECTANGLE) {
			dc.Rectangle(m_ptStart.x,m_ptStart.y,m_ptEnd.x,m_ptEnd.y);
		}
		else if (m_nShapeMode == ELLIPSE) {
			dc.Ellipse(m_ptStart.x,m_ptStart.y,m_ptEnd.x,m_ptEnd.y);
		}
		// ο  (,簢,Ÿ) ׸.
		dc.SetROP2(R2_NOT);
		if (m_nShapeMode == LINE) {
			dc.MoveTo(m_ptStart);
			dc.LineTo(point);
		}
		else if (m_nShapeMode == RECTANGLE) {
			dc.Rectangle(m_ptStart.x,m_ptStart.y,point.x,point.y);
		}
		else if (m_nShapeMode == ELLIPSE) {
			dc.Ellipse(m_ptStart.x,m_ptStart.y,point.x,point.y);
		}

		//   ǥ Ѵ.
		m_ptEnd = point; 
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	if (nChar == VK_SPACE) {
		if (m_nShapeMode == LINE)
			m_nShapeMode = RECTANGLE;
		else if (m_nShapeMode == RECTANGLE)
			m_nShapeMode = ELLIPSE;
		else if (m_nShapeMode == ELLIPSE)
			m_nShapeMode = LINE;
	}
	Invalidate();

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}
